(defun test-overriding-format (&optional file)
  (interactive "f")
  (let* ((file (or file (read-file-name "Org file for testing overriding format: ")))
	 (org-agenda-custom-commands
	  `(("t" "test" tags "filename={.+}"
	     ((org-agenda-files (quote (,file)))
	      (org-agenda-overriding-header
	       (concat
		"Test of overriding format: " "\n\n"
		(test-org-agenda-overriding-format "header" 0 nil nil '(("filename" .  "filename") ("birthday" . "birthday")))))
	      (org-agenda-property-list '("filename" "birthday"))
	      (org-agenda-overriding-agenda-format 'test-org-agenda-overriding-format)
	      (org-agenda-view-columns-initially nil))))))
    (push ?t unread-command-events)
    (call-interactively 'org-agenda)))

(defun test-org-agenda-overriding-format (hdr level category tags-list prop-list)
  (concat " " (test-trim-string hdr 20)
	  (let ((cprops prop-list)
		(pstring ""))
	    (while cprops
	      (let ((val (cdr (car cprops))))
		(cond ((string= (downcase (caar cprops)) "filename")
		       (setq val (file-name-nondirectory (org-link-display-format val)))))
		(setq pstring (concat pstring "  " (test-trim-string val  23))))
	      (setq cprops (cdr cprops)))
	    pstring) "\t"))

(defun test-trim-string (str len)
  "Trim string STR to a given length by either calling substring
or by adding whitespace characters."
  (let* ((slen (length str))
	 (diff (- len slen)))
    (if (> diff 0)
	(concat str (make-string diff (string-to-char " ")))
      (substring str 0 len))))

